#ifndef INIFILE_H
#define INIFILE_H

/*
   inifile.h

   Decls for INI file format functions

*/

#define INIFILE_MAX_LINELEN 256	/* max number of chars in a line */

#define COMMENT_CHAR ';'	/* signifies a comment */

  typedef struct
  {
    char tag[INIFILE_MAX_LINELEN];
    char rest[INIFILE_MAX_LINELEN];
  }
  INIFILE_ENTRY;

  const char *iniFind (void *fp,	/* already opened file ptr */
		      const char *tag,	/* string to find */
		      const char *section);	/* section it's in */

  int iniSection (void *fp,	/* already opened file ptr */
		 const char *section,	/* section you want */
		 INIFILE_ENTRY array[],	/* entries to fill */
		 int max);	/* how many you can hold */

#endif /* INIFILE_H */
