#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <errno.h>
#include "interface.h"

static FILE *logfp;

//nivelul curent de debug
int current_level = 0;

int log_open(const char * filename) {
    if (filename == NULL) {
	logfp = stdout;
    } else if (strcmp(filename, "stdout") == 0) { // daca e precizat stdout ca log
	logfp = stdout;
    } else {
	logfp = fopen(filename, "a+");
    }
    return RD_OK;
}

FILE * log_get_fp() {
    return logfp;
}

int log_set_level(int debug_level) {
    current_level = debug_level;
    return RD_OK;
}

int log_close(void) {
    fclose(logfp);
    return RD_OK;
}

int log_debug(int level, const char *fmt, ...) {
    va_list arg_ptr;
    
    if (current_level > level) {
	va_start(arg_ptr, fmt);
	vfprintf(logfp, fmt, arg_ptr);
	va_end(arg_ptr);
    }
    fflush(logfp);
    return RD_OK;
}

int log_hex(int level, char *s) {
    int i;
    
    if (current_level > level) {
	for (i=0; i < strlen(s); i++) {
	    fprintf(logfp," %2x",s[i]);
	}
	fprintf(logfp,"\n\r");
    }
    fflush(logfp);
    return RD_OK;
}

