#include "interface.h"

extern int serport;
extern int debug_level;
extern int no_console; // daca asteptam ceva de la consola
extern char commands[500]; // caractere venite pe seriala, si trebuie procesate
extern int command_ptr; // cate caractere sunt in commands[] de procesat (0 = niciunul, 1 = primul, etc)
static struct termios oldt, newt;

char convert(char ch){
    switch (ch) {
	case 0x40: return BTN_OK; break;
	case 0x41: 
	    log_debug(2,"SER_RX: a venit cancel (0x41)\n\r");
//	    while (wait_char(0x44) < 0) usleep(50000);
	    log_debug(2,"SER_RX: a venit si confirmarea (0x44)\n\r");
	    return BTN_CANCEL; 
	    break;
	case 0x42: return BTN_UP; break;
	case 0x43: return BTN_DOWN; break;
	default: return ch;
    }
}

int wait_char(char ch){
    int timeout = 5;
    char s[STR_LENGTH];
    int nr=0,i;
    int flag=-1;
    
    while (timeout-- > 0) {
	usleep(20000);
	if (!serhit()) continue;
	nr = read(serport, &s, 500);
	log_debug(6,"wait_char: %d caract. citit\n\r",nr);
	if (nr > 0) {
	    for (i=0; i<nr; i++) {
	        if (s[i] != ch) { //bagam la buffer
	    	    commands[command_ptr++] = convert(s[i]);
		    log_debug(6,"INPUTS_ser: commands[%d] = %c\r\n",command_ptr, commands[command_ptr-1]);
		} else { // a venit char, tinem minte, si bagam restu la buffer
		    flag = 1;
		}
	    }
	}
    }
    return flag; // n-a venit caracterul
}

void changemode(int dir) {
    if ( dir == 1 ) {
	tcgetattr( STDIN_FILENO, &oldt);
	newt = oldt;
	newt.c_lflag &= ~( ICANON | ECHO );
	tcsetattr( STDIN_FILENO, TCSANOW, &newt);
    } else {
	tcsetattr( STDIN_FILENO, TCSANOW, &oldt);
    }
}

int kbhit (void) {
  struct timeval tv;
  fd_set rdfs;

  tv.tv_sec = 0;
  tv.tv_usec = 0;

  FD_ZERO(&rdfs);
  FD_SET (STDIN_FILENO, &rdfs);

  select(STDIN_FILENO+1, &rdfs, NULL, NULL, &tv);
  return FD_ISSET(STDIN_FILENO, &rdfs);
}

int serhit(void) {
    int bytes=0;
    ioctl(serport, FIONREAD, &bytes);
    
    return bytes;
}


/* citeste de pe seriala modificari */
int check_inputs() {
    char s[STR_LENGTH];
    int num_cars=0,nc=0,i;

    if (!no_console) {
	while (kbhit()) {
	    commands[command_ptr++] = getchar();
	    log_debug(6,"INPUTS_key: commands[%d] = %c\r\n",command_ptr, commands[command_ptr-1]);
	    nc++;
	}
    }
    while (serhit()) {
	num_cars = read(serport,s,STR_LENGTH);
	log_debug(2,"SER_RX: au venit %d caractere: ", num_cars);
	for (i=0; i < num_cars; i++) {
	    log_debug(2,"%c(0x%x)",s[i]);
	}
	log_debug(2,"\n\r");
	
	if (num_cars <= 0) return num_cars;
	
	for (i=0; i < num_cars; i++) {
	    commands[command_ptr++] = convert(s[i]);
	    log_debug(6,"INPUTS_ser: commands[%d] = %c\r\n",command_ptr, commands[command_ptr-1]);
	}
	nc += num_cars;
    }
    return nc;
}
